PATH=$PATH:/bin:/usr/bin:tshark
export PATH
#!/bin/bash
# Take the input capture file as a command-line argument to the script
echo "Filtering input file for tcp streams and splitting them into seperate files"
IN_PCAP_FILE=$1
OUT_PCAP_FILE=FullConv-${IN_PCAP_FILE}
# Obtain the list of TCP stream IDs
TCP_STREAMS=$(tshark -r $IN_PCAP_FILE -Y "(tcp.flags.syn == 1 && tcp.flags.ack == 0) || (tcp.flags.syn == 1 && tcp.flags.ack == 1) && ip" -T fields -e tcp.stream | sort -n | uniq)

echo "${TCP_STREAMS}"
# Generate a new tshark filter for each stream ID
TSHARK_FILTER=""
for stream in $TCP_STREAMS; do
#  if [ "$TSHARK_FILTER" = "" ]; then
#	TSHARK_FILTER="tcp.stream==${stream}"
 # else
#	TSHARK_FILTER="${TSHARK_FILTER}||tcp.stream==${stream}"
	TSHARK_FILTER="ip && not ipv6 && tcp.stream==${stream}"
	OUT_PCAP_FILE=stream${stream}_${IN_PCAP_FILE}
	tshark -r $IN_PCAP_FILE -Y "${TSHARK_FILTER}" -w $OUT_PCAP_FILE
done

#TSHARK_FILTER="ip && udp"
#OUT_PCAP_FILE=udp_${IN_PCAP_FILE}
#tshark -r $IN_PCAP_FILE -Y "${TSHARK_FILTER}" -w $OUT_PCAP_FILE
# Apply the stream ID filter and write out the filtered capture file
#tshark -r $IN_PCAP_FILE -Y "${TSHARK_FILTER}" -w $OUT_PCAP_FILE

