#!/bin/bash

variable_array=()

CORES=$(grep -c processor /proc/cpuinfo)
PIDs=""
PORTS=()
#DATE=$(date +%s)
STARTTIME=$(($1+ 600))

INTERFACE=$(ip route show default | awk '/default/ {print $5}')
#$(ip link | awk -F: '$0 !~ "lo|vir|wl|^[^0-9]"{print $2;getline}') #change en to wl to show wired interface

MACSRC=$(cat /sys/class/net/${INTERFACE}/address)
MACDEST=$(arp -n | grep `route -n | awk '/UG/{print $2}'` | grep "192.168.178.1 " | awk '{print $3}')

#echo $INTERFACE
#echo $MACSRC
#echo $MACDEST


#unzip files
for file in $(find -maxdepth 1 -iname \*.zip); do
	unzip ${file}
	
done


for directory in $(find . -maxdepth 1 -type d); do
	if [[ ${directory} == "./"[0-9]* ]] ; then
				
		
	cd "${directory}"
	IP=${directory#./}
	#echo $directory
	MAPIPPREV=""
	INITIATORPREV=""
	for file in $(find . -maxdepth 1 -iname "*stream*"); do
		#execute all files in parallel
		#echo $file
		MAPIP=${file%%_*}
		MAPIP=${MAPIP#./}
		IPDSTPRE=${file#./*_}
		IPDSTPRE=${IPDSTPRE%%_*}
		#echo "HIER: $MAPIP"
		#echo "Und hier $MAPIPPREV"
		#echo $IPDSTPRE
		initiator="0"
		while read line; do
			if [[ ${line} == *${MAPIP}*  && ${line} == *${IP}* ]] ; then
				initiator="1"
			fi
			if [[ ${line} == *${IPDSTPRE}* ]] ; then
				IPDST=${line}
				IPDST=${IPDST#*.*.*.*[[:blank:]]}
				IPDST=${IPDST//[[:blank:]]}
			
			fi
 		done < ip_list.txt
 		
 		
 		
 		if [[ "$initiator" == "0" ]] ; then
 			while read line; do
				if [[ ${line} == *${MAPIP}* ]] ; then
					IPDST=${line}
					IPDST=${IPDST#*.*.*.*[[:blank:]]}
					IPDST=${IPDST//[[:blank:]]}
			
				fi
			
 			done < ip_list.txt
 		fi
 		
 		#echo $initiator
		PORTPRE=${file#*_*_*_*_}
		PORT=${PORTPRE%_*}
		#echo $PORTPRE
		#echo $PORT
		if [[ "$initiator" == "1" ]] ; then
			PORTS+=" $PORT"
		fi
		
		MAPIPPREV=${MAPIP}
		INITIATORPREV=${initiator}
		
		STARTOFFSET=${file##*_*_*_*_*_}
		#echo "Offset is $STARTOFFSET"
		#echo "STARTTIME is $STARTTIME"
		STARTTIME=$((${STARTTIME} + ${STARTOFFSET}))
		#echo "and now is $STARTTIME"
		
		#i=$(($i + 1))
		#echo $PORTS
		#echo $IPDST
		#echo $IP
		
		sleep 1
		sudo iptables -A OUTPUT -p tcp --tcp-flags RST RST -s ${IP} -d ${IPDST} --dport ${PORT} -j DROP
		echo "tcpliveplay ${INTERFACE} ${file} ${IPDST} ${MACDEST} ${PORT} ${STARTTIME} ${initiator}"
		sudo tcpliveplay ${INTERFACE} ${file} ${IPDST} ${MACDEST} ${PORT} ${STARTTIME} ${initiator} &
		
		PIDs="${PIDs} $!"
		#echo $PIDs
		STARTTIME=$(($1+ 600))
	done
	cd ..
	fi
done
#IPDEST=$IP
#for file in $(find . -iname \*_udp.pcap); do
	
#	STARTOFFSET=${file##*_*_}
#	STARTTIME=$(($STARTTIME + STARTOFFSET))
	
#	tcprewrite --cachefile=in.cache --endpoints=${IP}:${IPDEST} --enet-dmac=${MACDEST},${MACDEST} --enet-smac=${MACSRC},${MACSRC} --fixcsum --infile=${file} --outfile=${file}_rewrite.pcap
#	sudo tcpreplay -t --intf1=${INTERFACE} ${file}_rewrite.pcap ${STARTTIME} &
#	PIDs="${PIDs} $!"
	
#done

FILTER=""
i='0'
for value in ${PORTS[@]}; do
	#echo $value
	#echo $i
	if [[ ${i} == '0' ]] ; then
	FILTER="${FILTER}tcp port ${value}"		
			
	else
	FILTER="${FILTER} or tcp port ${value}"
	fi
	i=$(($i + 1))
done
echo $FILTER
if [[ "$FILTER" != "" ]] ; then
	sudo tshark -i ${INTERFACE} -f "${FILTER}" -w - > ${IP}_recording.pcap &
	TID="$!"
fi
wait ${PIDs}
echo "tcpliveplay returned"
sleep 1
if [[ "$FILTER" != "" ]] ; then
	read activetshark <<< $(pidof tshark)
	sudo kill $activetshark
fi


zip ${IP}_recording.zip ${IP}_recording.pcap

echo "When pssh doesn't return interrupt with strg+c"
exit 0
